function [f g]=funObj_deltaMultLogitGP(x,y,mean_,covMat, ind, M,N);

  alpha = x;
  % compute m 
  SigmaAlpha = covMat*alpha;
  m = mean_ + SigmaAlpha;

  % compute H and cholesky factor
  Mean = reshape(m,M,N);
  lse1mk = logsumexp([Mean; zeros(1,N)],1);
  g = exp(bsxfun(@minus, Mean, lse1mk));
  H = ind; % preallocate memory as blk sparse matrix 
  UH = ind;
  for n = 1:N
    idx = (n-1)*M + 1:n*M;
    Hn = diag(g(:,n)) - g(:,n)*g(:,n)';
    Hn = Hn + eps*eye(M);
    UHn = cholinc(sparse(Hn), struct('droptol',1e-10));
    %[UHn,posdef] = cholproj(Hn);
    H(idx,idx) = Hn;
    UH(idx,idx) = UHn;
  end
  %[min(diag(full(UH))) max(diag(full(UH)))]

  % compute V and A
  B = eye(N*M) + UH*covMat*UH';
  U = chol(B);
  %[min(diag(U)) max(diag(U))]
  A = UH\(U\(U'\UH));
  V = A*covMat;

  % compute C
  %C = A'*covMat + V*A' - V*A;
  C = A'*covMat + V*A' - A*V;
  C = ind.*C;

  % objective function
  f = -0.5*(2*sum(log(diag(U))) + trace(A) + alpha'*SigmaAlpha - M*N)...
      + y'*m - sum(lse1mk) - 0.5*trace(H*V);

  % copmute gradient
  g = g(:);
  %g = -0.5*H*diag(C) + H*C*g - alpha + y - g;
  g = -0.5*H'*diag(C) + 0.5*H'*(C+C')*g - alpha + y - g;
  g = covMat*g;

  f=-f;
  g=-g;

