function [f,g]=funObj_logBoundMultLogitGPReg(x,y,mean_,covMat,M,N);

  alpha = x(1:M*N);
  lambda = exp(x(M*N+1:end));

  % compute m 
  SigmaAlpha = covMat*alpha;
  m = mean_ + SigmaAlpha;

  % compute V and A
  slambda = sqrt(lambda);
  B = eye(N*M) + diag(slambda)*covMat*diag(slambda);
  U = chol(B);
  Uinv = U\eye(M*N);
  A = diag(1./slambda)*Uinv*Uinv'*diag(slambda);
  V = A*covMat;

  % compute t
  t = exp(m + diag(V)/2);
  t = reshape(t,M,N);
  t_norm = sum([t; ones(1,N)]);
  t = bsxfun(@times, t, 1./t_norm);
  t = t(:);

  % objective function
  f = -0.5*(2*sum(log(diag(U))) + trace(A) + alpha'*SigmaAlpha - M*N)...
      + y'*m - sum(log(t_norm));

  % gradients
  galpha = -SigmaAlpha + covMat*(y -t);
  glambda = -0.5*(diag(V) - diag(V*A')) + 0.5*(V.^2)*t;

  % due to reparamatrization as exponential in lambda
  glambda = lambda.*glambda;

  g = [galpha; glambda];

  g=-g;
  f=-f;

