function [f,g]=funObj_stickLogitGP(x,y,mean_,covMat,M,N, bound, ind);

  alpha = x(1:M*N);
  lambda = exp(x(M*N+1:end));

  % compute m 
  m = mean_ + covMat*alpha;

  % compute V and A
  slambda = sqrt(lambda);
  B = eye(N*M) + diag(slambda)*covMat*diag(slambda);
  U = chol(B);
  Uinv = U\eye(M*N);
  A = diag(1./slambda)*Uinv*Uinv'*diag(slambda);
  V = A*covMat;

  % bound contribution
  [f, gm, gv] = funObj_pw(m, diag(V), bound);
  f = ind.*f;
  gm = ind.*gm;
  gv = ind.*gv;

  % objective function
  SigmaAlpha = covMat*alpha;
  f = -0.5*(2*sum(log(diag(U))) + trace(A) + alpha'*SigmaAlpha - M*N)...
      + y'*m - sum(f);

  % gradients
  galpha = -SigmaAlpha + covMat*(y - gm);
  glambda = -0.5*(diag(V) - diag(V*A')) + (V.^2)*gv;

  % due to reparamatrization to exponential in lambda
  glambda = lambda.*glambda;

  g = [galpha; glambda];

  g=-g;
  f=-f;

