function [m_s, V_s] = getPredictDistMultiClassGP(mu_s, Sigma_ss, Sigma_s, alpha, U, sLambda)
% mu_s is mu(x*)
% Sigma_s is Sigma(x*,x)
% Sigma_ss is Sigma(x*,x*)
% alpha is reparamterized Sigma*(m- mu)
% sLambda is the cholesky decomposition of Lambda when V is 
% parameterized as V = inv(inv(Sigma) + Lambda)
% U is chol(I + sLambda*Sigma*sLambda')
%
% Written by Emtiyaz, CS, UBC
% Modified on September 20, 2011

  m_s = mu_s + Sigma_s*alpha; 
  T_s = U'\sLambda*Sigma_s';
  V_s = Sigma_ss - T_s'*T_s;
