function [params, options] = maxParamsCatLGM_gaussianPrior(ss, data, params, options)

  L = length(params.mean);
  N = size(data.Y,2);

  [estimateMean, estimateCovMat] = myProcessOptions(options, 'estimateMean', 0, 'estimateCovMat', 0);

  if estimateMean
    params.mean = ss.mean;
    den = params.hyp.nu0 + L + 1 + N;
    if estimateCovMat
      params.covMat = (params.hyp.S0 + N*ss.covMat)/den - N*params.mean*params.mean'/den;
      params.precMat = inv(params.covMat);
      params.logDetCovMat = logdet(params.covMat); 
    end
  else 
    den = params.hyp.nu0 + L + 1 + N;
    if estimateCovMat
      params.covMat = (params.hyp.S0 + N*ss.covMat)/den;
      params.precMat = inv(params.covMat);
      params.logDetCovMat = logdet(params.covMat); 
    end
  end


