function [params, options] = maxParamsCatLGM_bohning(ss, data, params, funObj, options)
% Mstep function for multiLogitLGM parameter learning using the bohning bound
% on LSE function
%
% Written by Emtiyaz, CS, UBC
% Modified on Dec. 5, 2011

  [estimateLoadingMat, estimateBias] = myProcessOptions(options, 'estimateLoadingMat', 0, 'estimateBias', 0);

  % mean and CovMat
  [params, options] = maxParamsCatLGM_gaussianPrior(ss, data, params, options);

  % loadingMat and bias
  if estimateLoadingMat
    D = params.others.nDim;
    nC = params.others.nClass-1;
    Widx = params.others.loadingMatIdx;
    W = params.loadingMat(Widx,:);
    w0 = params.bias(Widx);
    if size(ss.rhs,3)==1
      % if no missing values
      rhs = inv(ss.rhs);
      for i = 1:1
        W = (-w0*ss.sumMean' + ss.iAYplusBm)*rhs;
        w0 = ss.iAsumYplusBm - W*ss.sumMean;
      end
    else
      % otherwise
      for d = 1:D
        idx = sum(nC(1:d-1))+1:sum(nC(1:d));
        Wd = W(idx,:);
        w0d = w0(idx,:);
        rhs = inv(ss.rhs(:,:,d));
        for i = 1:1
          lhs = -w0d*ss.sumMean(:,d)' + ss.iAYplusBm(idx,:);
          Wd = lhs*rhs;
          w0d = ss.iAsumYplusBm(idx,:) - Wd*ss.sumMean(:,d);
          w0d = ss.NoverNd(d)*w0d;
        end
        W(idx,:) = Wd;
        w0(idx,:) = w0d;
      end
    end
    params.loadingMat(Widx,:) = W;
    params.bias(Widx) = w0;
  end

  % initVec
  if isfield(ss, 'initVec')
    options.initVec = ss.initVec;
  end

